# -*- rpm-spec -*-
%define module_name	bcmwl
%define module_version  6.30.223.271
%define real_version	6.30.223.271
# for patched version
%define git 6adc981

#### MODULE SOURCES ####
Name: kernel-source-%module_name
Version: %module_version
Release: alt11.g%{git}
Provides: kernel-source-%module_name-%module_version
Summary: Linux %module_name Broadcom WiFi chipset series module sources
License: Proprietary
Group: Development/Kernel
Url: https://github.com/antoineco/broadcom-wl
Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>

Source0: %name-%real_version.tar

ExclusiveArch: %ix86 x86_64
BuildPreReq: kernel-build-tools

%description
%module_name module sources for Linux kernel.

Patched for Linux >= 4.7

%package -n bcmwl-kernel-conf
Summary: bcmwl kernel module configuration
Group: System/Kernel and hardware
BuildArch: noarch

%description -n bcmwl-kernel-conf
bcmwl kernel module configuration.

%prep
%setup -c -q

%install
# blacklist several modules (see ALT bugs #26265, #26250)
mkdir -p %buildroot/%_sysconfdir/modprobe.d
cat > %buildroot/%_sysconfdir/modprobe.d/blacklist-bcm.conf << __EOF__
blacklist bcm43xx
blacklist ssb
blacklist b43
__EOF__
cat > %buildroot/%_sysconfdir/modprobe.d/blacklist-bcm2.conf << __EOF__
blacklist b44
blacklist b43legacy
blacklist bcma
blacklist brcmsmac
blacklist brcmfmac
blacklist bcma-pci-bridge
__EOF__

mkdir -p %kernel_srcdir
%ifarch %ix86
rm -f %name-%version/bcmwl/lib/wlc_hybrid.o_shipped
mv %name-%version/bcmwl/lib/wlc_hybrid.o_shipped.i386 %name-%version/bcmwl/lib/wlc_hybrid.o_shipped
%endif
tar jcf %kernel_srcdir/%name-%version.tar.bz2 %name-%version/bcmwl

%files
%attr(0644,root,root) %kernel_src/%name-%version.tar.bz2

%files -n bcmwl-kernel-conf
%config(noreplace) %_sysconfdir/modprobe.d/blacklist-bcm.conf
%config(noreplace) %_sysconfdir/modprobe.d/blacklist-bcm2.conf

%changelog
* Mon Jun 30 2025 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt11.g6adc981
- Apply patches from debian for 6.15+ compatibility:
  + 38-build-don-t-use-deprecated-EXTRA_-FLAGS.patch
  + 39-wl-use-timer_delete-for-kernel-6.15.patch
  + 40-wl-add-MODULE_DESCRIPTION.patch

* Fri Apr 18 2025 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt10.g6adc981
- Added fix for kernels 6.13+.

* Fri Jan 17 2025 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt9.g6adc981
- Apply some fixes from debian:
  + wl: Avoid disconnecting invalid interface
  + wl: Fix get/set values for tx_power
  + wl: Make sure power_mgmt settings are honored

* Fri Dec 20 2024 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt8.g6adc981
- Added fix for kernels 6.12+ (due upstream 5f60d5f6 commit).

* Thu Feb 08 2024 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt7.g6adc981
- Restore 32-bit support (closes #49323).
- Remove forbidden conflicts to kernel-modules-bcmwl.

* Wed Apr 05 2023 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt6.g6adc981
- Add kernel-module configuration subpkg (closes #45082).

* Wed Oct 19 2022 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt5.g6adc981
- GIT 6adc981 from github (kernel 6.x compatible).

* Sat Apr 16 2022 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt4.gb76c5dc
- GIT b76c5dc from github (kernel 5.18 compatible).
- Drop %%ix86 support (who cares).

* Fri Dec 10 2021 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt3
- Make sources arch dependant.

* Tue May 18 2021 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt2
- Use version from github patch for 4.7+ compatibility.

* Wed Jun 29 2016 L.A. Kostis <lakostis@altlinux.ru> 6.30.223.271-alt1
- 6.30.223.271.

* Wed Aug 07 2013 Anton V. Boyarshinov <boyarsh@altlinux.ru> 6.30.223.30-alt1
- 6.30.223.30

* Thu Jan 12 2012 Anton V. Boyarshinov <boyarsh@altlinux.ru> 5.100.82.112-alt1
- 5.100.82.112

* Thu Sep 02 2010 Anton V. Boyarshinov <boyarsh@altlinux.ru> 5.60.48.36-alt1
- 5.60.48.36

* Mon Jan 11 2010 Anton V. Boyarshinov <boyarsh@altlinux.ru> 5.10.91.9.3-alt3
- Build on i586 fixed

* Wed Dec 30 2009 Anton V. Boyarshinov <boyarsh@altlinux.ru> 5.10.91.9.3-alt2
- 5.10.91.9.3

* Tue May 26 2009 Michail Yakushin <silicium@altlinux.ru> 5.10.91.9-alt1
- 5.10.91.9

* Tue Apr 07 2009 Michail Yakushin <silicium@altlinux.ru> 5.10.79.10-alt2
- fix Summary 

* Wed Mar 25 2009 Michail Yakushin <silicium@altlinux.ru> 5.10.79.10-alt1
- initial build 


